<?php

namespace App\Classes\Jobs\Commands\V2;

use App\Classes\Modules\Bookings\Processors\RegenerateInvoiceBookingV2Processor;
use Carbon\Carbon;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;
use App\Models\Booking;
use Illuminate\Support\Facades\Log;


class OneTimeBatchProcessEInvoicesV2CommandJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /** @var Booking */
    private $booking;

    /**
     * OneTimeBatchProcessEInvoicesV2CommandJob constructor.
     * @param Booking $booking
     */
    public function __construct(Booking $booking)
    {
        $this->booking = $booking;
    }

    public function handle()
    {
        Log::info(Carbon::now() . ': Start job - Processing single booking for E-Invoices for July 2025.');
        $start   = new Carbon();

        $isAllowNormalInvoice = true;
        (App()->make(RegenerateInvoiceBookingV2Processor::class))->execute($this->booking, $isAllowNormalInvoice);

        $end = new Carbon();
        $elapsedTime = $start->diff($end)->format('%H:%I:%S');
        Log::info(Carbon::now() . ': End job - Processing single booking for E-Invoices for July 2025. ElapsedTime: ' . $elapsedTime . '.');
    }
}
